#gigglebubble.py
#See http://www.mrexcessive.net/games
#
#Temporal Solitaire for the underbusy
#This is free software in the http://www.fsf.org/ sense
#It uses pygame, http://www.pygame.org/

try:
   import os,sys,getopt
   import random
   import math
   import pygame, pygame.font, pygame.mixer, pygame.image, pygame.transform
   import pygame.sprite
   from pygame.locals import *
except ImportError, err:
   print "couldn't load module. %s" % (err)
   sys.exit(2)

#YYY = explain. ZZZ = todo. XXX = bad thing to remove/replace

#ZZZ. pinball like things in background to try to achieve
#ZZZ. Build in walkclues to decrypt special levels !(walk photos)


addanotherball = 0
score = 0
level = 1
level_limit = 2      # number of gold on first level (+1 thereafter)
level_countballs = 0
gravity = .05        # accel due to gravity
silent = 0  # allow sounds
background = None
walkpattern_circle = []
OPTIONS = {}

#game global options, controlled by command line
def usage():
   print "Usage:"
   print "python gigglebubble.py [-F]"
   print "   -f   =   Fullscreen mode"
   print "   -h   =   Print usage information"
   print "   -x   =   Run mygamebox at end and update scores"
   print

def setup_walkpatterns():
   #walkpattern_circle
   #ZZZ test only, line
   steps = 200
   rotate = 10 * math.pi    # 5 circles, well 2 circles and then spirals in and out
   justcirclestill = 2 * (steps / 10)
   rotstep = rotate / steps
   startradius = 100
   radius = startradius
   radiusreduce =  (startradius  * 2.0) /  (7 * (steps / 10)) # so gets back out -ve at end
   angle = math.pi / 2   # start at top
   valx,valy = (0,startradius)
   for i in range(steps):
      if i >= justcirclestill:
         radius -= radiusreduce
         #ZZZ consider changing angle ? (add another couple of rotsteps ?)
      nx = radius * math.cos(angle)
      ny = radius * math.sin(angle)
      dx = valx - nx
      dy = valy - ny
      valx = nx
      valy = ny
      walkpattern_circle.append((dx,dy))
      #print int(dx),int(dy)," : ",int(nx),int(ny)
      angle += rotstep

def load_image(name, colorkey=None):
   fullname = os.path.join('data',name)
   try:
      image = pygame.image.load(fullname)
   except pygame.error, message:
      print 'Cannot load image:', name
      raise SystemExit, message
   image = image.convert()
   if colorkey is not None:
      if colorkey is -1:
         colorkey = image.get_at((0,0))
      image.set_colorkey(colorkey, RLEACCEL)
   return image, image.get_rect()
   
def load_sound(name):
   if not pygame.mixer:
      return NoSound()
   fullname = os.path.join('data',name)
   try:
      sound = pygame.mixer.Sound(fullname)
   except pygame.error, message:
      print 'Cannot load sound:', name
      raise SystemExit, message
   return sound

def load_music(name):
   if not pygame.mixer.music:
      return NoneSound()
   fullname = os.path.join('data',name)
   try:
      music = pygame.mixer.Sound(fullname)
   except pygame.error, message:
      print 'Cannot load music:', name
      raise SystemExit, message
   return music


def set_background():
   global level,background
   fnames = ['christchurch.jpg','weather.jpg','cathedral.jpg','ceiling.jpg','smallbridge.jpg','heddoncottage.jpg']
   fnames = fnames + ['snowbound.jpg','geese.jpg']
   fname = fnames[(level-1) % len(fnames)]
   bgimage,bgrect = load_image(fname,-1)
   bgimage = bgimage.convert()
   bgimage.set_alpha(192)        # slightly faded
   background = pygame.Surface(screen.get_size())
   background.blit(bgimage,(0,0))
   #Put level text on screen
   #YYYChange to use messages, maybe somehow. oneday
   font = pygame.font.Font("kitchen.ttf",36)
   text = font.render("LEVEL " + str(level), 1, (235,220,255))
   textpos = text.get_rect()
   textpos.centerx = background.get_rect().centerx
   background.blit(text,textpos)
   return background


class Nosound:
   def __init__(self):
      pass
   def play(self):
      pass
   def set_volume(self,val):
      pass
  
class Fist(pygame.sprite.Sprite):
   """moves a clenched fist on the screen, following the mouse"""
   def __init__(self):
      pygame.sprite.Sprite.__init__(self)    #call Sprite initialiser
      self.image, self.rect = load_image('fist.png', -1)
      self.punching = 0
   
   def update(self):
      "move the fist based on the mouse position"
      pos = pygame.mouse.get_pos()
      self.rect.midtop = pos
      if self.punching:
         self.rect.move_ip(5,10)
   
   def punch(self,targetlist):
      "returns true if the fist collides with the target"
      if not self.punching:
         self.punching = 1
         hitbox = self.rect.inflate(-15, -15)
         targets = [target.rect for target in targetlist]
         collidelist = hitbox.collidelistall(targets)
         if collidelist != []:
            whathit = [targetlist[each] for each in collidelist]
            return whathit[0:2]     # max 3 things
         else:
            return []
         
   def unpunch(self):
      "called to pull the fist back"
      self.punching = 0
      
class Message(pygame.sprite.Sprite):
   """a message to user"""
   font = {}
 
   def __init__(self,msg,colour=None,fontsize=36,finaloffset = (0,0)):
      pygame.sprite.Sprite.__init__(self)
      a=1
      if not Message.font.has_key(fontsize):
         Message.font[fontsize] = pygame.font.Font("kitchen.ttf",fontsize)      # oh so big ZZZ get new free/nice ttf      
      if not colour:
         colour = ( random.randint(100,255), random.randint(100,255), random.randint(100,255) )
      text = Message.font[fontsize].render( msg, 1, colour )
      self.image = text
      self.area = screen.get_rect()       # where it is allowed to be
      self.rect = self.image.get_rect()
      self.rect.midtop = background.get_rect().midtop
      self.finaloffset = finaloffset
      self.move = (0,+5)
      self.moving = 2
      self.tigger = 3
      
   def flyoff(self):
      self.move = (+7,-6)
      self.moving = 1
   
   def update(self):
      """ZZZmove and draw"""
      if self.moving:               # flying in(2) or out(1)
         newpos = self.rect.move(self.move)
         if self.moving == 1:       # out(1)
            if not self.area.colliderect(newpos):
               self.kill()
            else:
               self.rect = newpos
         elif self.moving == 2:     # heavy gravity bounce score until slow
            self.newmove = (self.move[0],self.move[1]+gravity*8)
            self.testarea = self.area.move(self.finaloffset)   # the bounce against floor at resting place offset
            if not self.testarea.contains(newpos):
               self.tigger -= 1
               if not self.tigger:  # stop bouncing
                  self.moving = 0
               else:          # lose some energy on the bounce
                  self.move = (self.move[0],-self.move[1]*0.8)
                  newpos = self.rect.move(self.move)
                  self.rect = newpos
            else:
               self.move = self.newmove
               self.rect = newpos
            
      
class Gold(pygame.sprite.Sprite):
   """a ball moves across the screen"""
   dizzycounter = 0     # how many Gold are dizzy
   dizzylimit = 1
   
   def __init__(self,image,(xy),(dxdy),dizzymax = 360):
      pygame.sprite.Sprite.__init__(self)    # call Sprite initialiser
      self.image, self.rect = load_image(image, -1)
      self.original = self.image
      screen = pygame.display.get_surface()
      self.area = screen.get_rect()
      self.rect.topleft = xy
      (rx,ry) = ( random.randrange(1,dxdy[0]),random.randrange(1,dxdy[1]) )
      direction = random.randrange(4)
      if direction == 0:
         self.move = (rx,ry)
      elif direction == 1:
         self.move = (ry,rx)
      elif direction == 2:
         self.move = (-rx,ry)
      elif direction == 3:
         self.move = (-ry,-rx)
      self.dizzy = 0
      self.silly = 0
      self.dizzymaxangle = dizzymax
      self.pause = 0    # not pausing (countdown otherwise in walk)
      
   def update(self):
      "walk or spin, depending on the gold ball's state"
      if self.dizzy:
         self.spinme()
      else:
         self.walkme()
         
   def speedup(self):
      pass#self.move = (self.move[0]*1.1,self.move[1]*1.1)
         
   def set_dizzypause(self,new_dizzy,new_pause):
      self.dizzy = new_dizzy
      self.pause = new_pause
      
   def set_dizzylimit(self,new_dizzylimit):
      Gold.dizzylimit = new_dizzylimit
      
   def zero_dizzycounter(self):
      Gold.dizzycounter = 0      # YYY e.g. remove all Gold so start counting again
      
   def set_silly(self,new_silly):
      self.silly = new_silly
         
   def walkme(self):
      "move the ball around"
      if self.pause:
         self.pause -= 1
         if self.pause < 10:
            self.image.set_alpha(255)
      elif self.silly == 0 or self.silly == 1:                 # normal with gravity
         vertical = self.move[1]
         vertical = vertical + gravity
         self.move = (self.move[0],vertical)
         newpos = self.rect.move(self.move)
         if not self.area.contains(newpos):
            tl = not self.area.collidepoint(newpos.topleft)
            tr = not self.area.collidepoint(newpos.topright)
            bl = not self.area.collidepoint(newpos.bottomleft)
            br = not self.area.collidepoint(newpos.bottomright)
            if tl and tr or (bl and br):
               self.move = (self.move[0],-self.move[1])
            if tr and br or (tl and bl):
               self.move = (-self.move[0],self.move[1])
            newpos = self.rect.move(self.move)
         self.rect = newpos
      else:
         print "Error. Bad silly walk"
   
   def spinme(self):
      "spin the image (ie. show it's been hit - however)"
      center = self.rect.center
      self.dizzy += 8      # rotate a bit
      if self.dizzy >= self.dizzymaxangle:
         self.dizzy = 0
         if Gold.dizzycounter == Gold.dizzylimit:
            #when continuing to move, check the dizzycounter
            if not silent: gotthem_sound.play()
            global addanotherball
            addanotherball = 1
            #also speed this ball up a bit
            #self.move = (-self.move[0]*1.05,self.move[1]*1.1)
         Gold.dizzycounter -= 1
         self.pause = 30
         self.image = self.original
         self.image.set_alpha(128)  # hide a bit
         if not silent: pause_sound.play()   # giggle
      else:
         rotate = pygame.transform.rotate
         self.image = rotate(self.original,self.dizzy)
      self.rect = self.image.get_rect()
      self.rect.center = center
   
   def punched(self):
      "this will cause the gold to start spinning"
      if not self.dizzy:         # only count as newly spinning if wasn't spinning before
         self.dizzy = 1
         self.silly = 0
         Gold.dizzycounter += 1
         return 1
      else:
         self.dizzy = 1
         return 1


class GoldSpiral(Gold):
   def __init__(self,image,(xy),dizzymax = 360):
      #ZZZ remove unnecessary parameters
      pygame.sprite.Sprite.__init__(self)    # call Sprite initialiser
      self.image, self.rect = load_image(image, -1)
      self.original = self.image
      screen = pygame.display.get_surface()
      self.area = screen.get_rect()
      self.rect.topleft = xy
      self.walk = [ (2,100,(0,0)), (1,50,(7,3)), \
         (2,100,(0,0)), (1,50,(-3,7)), \
         (2,100,(0,0)), (1,50,(-9,-5)),    # weight it back to top left \
         (2,100,(0,0)), (1,50,(3,-7)),
      ]
      self.walkstate = 0   # read instruction
      self.walkpointer = 0 # index to walk
      self.walking = 0     # shouldn't need init here, but no count left anyway
      self.walkmove = (0,0)  # shouldn't need init here, but zero move anyway
      self.walktype = 0 # also not nec.
      self.dizzy = 0
      self.silly = 0
      self.dizzymaxangle = dizzymax
      self.pause = 0    # not pausing (countdown otherwise in walk)

   def walkme(self):
      "move the ball around"
      if self.pause:
         self.pause -= 1
         if self.pause < 10:
            self.image.set_alpha(255)
      elif self.silly == 0 or self.silly == 1:                 # normal with gravity
         if self.walkstate == 0:
            if self.walkpointer == len(self.walk) :       # no more instructions
               self.walkpointer = 0
            (self.walktype,self.walking,self.walkmove) = self.walk[self.walkpointer]
            #YYY debug:print "got " + repr((self.walktype,self.walking,self.walkmove))
            self.walkpointer += 1
            self.walkstate = 1
         elif self.walkstate == 1:
            if self.walking > 0:
               self.walking -= 1
               if self.walktype == 1:
                  newpos = self.rect.move(self.walkmove)
                  if self.area.contains(newpos):
                     self.rect = newpos
                  else:                                  # ZZZ handle bounce better
                     self.walkmove = (0,0)                # ZZZ for now just move to next step
                     self.walkstate = 0
               elif self.walktype == 2:
                  #ZZZ for now just global circle, use self.move and turn right
                  global walkpattern_circle
                  #self.walkmove = walkpattern_circle[len(walkpattern_circle) - (self.walking + 1)]
                  self.walkmove = walkpattern_circle[self.walking]
                  #ZZZ maybe do the newpos checks in one place...zzz
                  newpos = self.rect.move(self.walkmove)
                  if self.area.contains(newpos):
                     self.rect = newpos
                  else:                                  # ZZZ handle bounce better
                     self.walkmove = (0,0)                # ZZZ for now just move to next step
                     self.walkstate = 0
               else:
                  raise "Bad walktype"
            if self.walking == 0:
               self.walkstate = 0                              # get a new instruction next time
         else:
            raise "Bad walkstate"
      else:
         print "Error. Bad silly walk"
   


def load_resources():
   "load everything needed"
   global whiff_sound, punch_sound, newone_sound, gotthem_sound
   global pause_sound, uplevel_sound, music
   whiff_sound = load_sound('whiff.wav'); whiff_sound.set_volume(0.2)
   punch_sound = load_sound('punch.wav'); punch_sound.set_volume(0.4)
   newone_sound = Nosound()#load_sound('drumroll.wav'); newone_sound.set_volume(1.0)
   gotthem_sound = load_sound('bionics.wav'); gotthem_sound.set_volume(0.4)
   pause_sound = load_sound('giggle.wav'); pause_sound.set_volume(0.3)
   uplevel_sound = load_sound('woo-hoo.wav'); uplevel_sound.set_volume(1.0)
   music = Nosound()#load_music('music.wav')
   music.set_volume(0.5)
   global allgold
   allgold = []
   if 1:       #start smallest off fast
      allgold.append( GoldSpiral('greensmall.png',(250,110),360) )
      allgold.append( Gold('goldsmall.png',(50,50),(4,3),360) )
      allgold.append( Gold('bluesmall.png',(150,150),(6,5),720) )
   if 1:    # YYY testing, easy to just do 2 gold
      allgold.append( Gold('blacktiny.png',(250,110),(5,3),1080) )
      allgold.append( Gold('goldsmall.png',(50,50),(4,3),360) )
      allgold.append( Gold('rainbowsmallstar.png',(200,130),(8,9),10) )
      allgold.append( Gold('redtiny.png',(250,110),(5,3),720) )
      allgold.append( Gold('bluesmall.png',(150,150),(7,5),720) )
      allgold.append( Gold('blacktiny.png',(250,110),(3,8),1080) )
      #allgold.append( Gold('rainbowsmallstar.png',(130,200),(12,12),10) )
      allgold.append( Gold('redtiny.png',(250,110),(9,4),720) )
      allgold.append( GoldSpiral('greensmall.png',(250,110),360) )
      allgold.append( Gold('redtiny.png',(250,110),(4,11),720) )
      allgold.append( Gold('greensmall.png',(250,110),(6,2),360) )
      allgold.append( Gold('blacktiny.png',(250,110),(3,12),1080) )
   setup_walkpatterns()


def all_levels():
 global addanotherball,score,level,allgold,gold,level_limit,level_countballs,background,silent
 pygame.init()    # setup image
 background = set_background()
 screen.blit(background,(0,0))
 pygame.display.flip()
 # Reset things, after all main() plays the game, once highscore and splash page added then main will get called multiple times
 addanotherball = 0
 score = 0
 level = 1
 level_limit = 2      # number of gold on first level (+1 thereafter)
 level_countballs = 0
 gold = []
 gold.append(allgold.pop(0))
 fist = Fist()
 messages = []
 noscore = Message("Score ZILCH!",colour=(64,255,192),finaloffset=(0,-80))
 messages.append(noscore)
 use_skey = Message("'s' to toggle sound",fontsize=24,colour=(255,255,64),finaloffset=(0,-30))
 messages.append(use_skey)
 goldsprites = pygame.sprite.RenderUpdates(gold)
 fistsprites = pygame.sprite.RenderUpdates([fist])
 messagesprites = pygame.sprite.RenderUpdates(messages)
 clock = pygame.time.Clock()
 while 1:
   changed_rects = []
   if addanotherball:
      addanotherball = 0
      level_countballs += 1
      if level_countballs == level_limit:
         level += 1
         level_limit += 1
         newlevel = Message( "END OF LEVEL" )#, (255,255,50) )
         newlevel.rect.center = background.get_rect().center
         messages.append(newlevel)
         messagesprites.add([newlevel])
         if not silent: uplevel_sound.play()
         [each.speedup() for each in gold]
         [each.set_dizzypause(0,0) for each in gold]
         allgold = gold + allgold
         gold = []
         goldsprites.empty()
         newball = allgold.pop(0)
         newball.zero_dizzycounter()
         level_countballs = 1
         background = set_background()
         screen.blit(background,(0,0))
         changed_rects = [background.get_rect()]
      else:
         newball = allgold.pop(0)
      gold.append(newball)
      newball.set_dizzylimit(len(gold))
      newball.set_silly(1)
         # silly is the movement pattern to use. 0 is default bounce no gravity
      goldsprites.add([newball])
      if not silent: newone_sound.play()
      score += 5 * len(gold)
      newscore = Message("Score " + "%000d" % score)
      for message in messages:
         message.flyoff()
      messages.append(newscore)
      messagesprites.add([newscore])
   clock.tick(24)       # limit fps
   for event in pygame.event.get():
      if event.type is QUIT:
         return 0
      elif event.type is KEYDOWN:
         if event.key is K_ESCAPE:
            return 0
         elif event.key == K_s:
            silent = not silent
      elif event.type is MOUSEBUTTONDOWN:
         whathitlist = fist.punch(gold)
         if whathitlist:
            for somethinghit in whathitlist:
               if somethinghit.punched():
                  if not silent: punch_sound.play()   # punch
         else:
            if not silent: whiff_sound.play()   # miss
      elif event.type is MOUSEBUTTONUP:
         fist.unpunch()
   
   #undraw the sprites
   fistsprites.clear(screen,background)
   goldsprites.clear(screen,background)
   messagesprites.clear(screen,background)

   #move the sprites
   messagesprites.update()
   goldsprites.update()
   fistsprites.update()

   #draw the sprites
   changed_rects = changed_rects + messagesprites.draw(screen) + goldsprites.draw(screen) + fistsprites.draw(screen)
   pygame.display.update(changed_rects)


def main():
   levels = {}    # GiggleBubble deals with all levels inside level
   while 1:
      alive = all_levels()    # player has no time limit, so cannot be killed per se.
      if not alive:
         return


def rungamebox(scoresinfo):
   os.chdir('../mygamebox')
   #ZZZ store central information and/or pass or maintain flag settings (e.g -f fullscreen)
   #ZZZ write scoresinfo to a file (use a standard module for this)
   RUN = ['python','mygamebox.py','-s','scoresfile'];
   t = open('trace','w+')
   try:
      os.execvp('python',RUN)       # this doesn't return
   except:
      print >> t, "couldn't restart gamebox", sys.exc_info()[0]
      print >> t, "suppl ", sys.exc_info()[1]
   t.close()

def play_standalone():
   global OPTIONS,screen
   OPTIONS['fullscreen'] = 0
   OPTIONS['fromgamebox'] = 0
   try:
      opts, args = getopt.getopt(sys.argv[1:], "hfx", ["help", "output=","fromgamebox"])
   except getopt.GetoptError:
      usage()
      sys.exit(2)
   for o, a in opts:
      if o in ("-h", "--help"):
         usage()
         sys.exit()
      if o == '-f':
         OPTIONS['fullscreen'] = 1
      if o == '-x':
         OPTIONS['fromgamebox'] = 1
   pygame.init()
   if OPTIONS['fullscreen']:
      screen = pygame.display.set_mode((640,480),FULLSCREEN)      # ZZZ consider 800x600 upgrade
   else:
      screen = pygame.display.set_mode((640,480))
   # We need better than 8 bit color depth
   if screen.get_bytesize() < 2:
      print "This program requires more than 256 colours."
      print "Please change your display to 16bit or 32bit colour."
      raise SystemExit
   pygame.display.set_caption('excessive B O M B E R S')
   pygame.mouse.set_visible(0)
   load_resources()
   main()
   if OPTIONS['fromgamebox']:
      print "returning to gamebox"
      rungamebox('dummyscoresinfo')



#STARTS HERE
if __name__ == '__main__':
   play_standalone()
   
# end of file gigglebubble.py


